
MESSAGE(STATUS "setting up Xmlbeansxx MACROS.")

IF (WIN32)
	SET(EXEC_SUF ".bat")
	IF (CMAKE_BUILD_TYPE STREQUAL Debug) 
    		SET(LIB_SUF "d")
  	ENDIF (CMAKE_BUILD_TYPE STREQUAL Debug) 
ELSE (WIN32) 
	SET(EXEC_SUF "")
	SET(LIB_SUF "")
ENDIF (WIN32)


SET(XMLBEANSXX_GEN_PROG		${PROJECT_BINARY_DIR}/generator/target/xmlbeansxx-gen/bin/xmlbeansxx-gen${EXEC_SUF})
SET(XMLBEANSXX_GENBUILDIN_PROG 	${PROJECT_BINARY_DIR}/generator/target/xmlbeansxx-gen/bin/xmlbeansxx-genbuiltin${EXEC_SUF}) 
SET(XMLBEANSXX_LIB xmlbeansxx${LIB_SUF})



MACRO(XMLBEANSXX_GEN XSD SRC_C SRC_H)
	SET(${XSD}_SRC ${CMAKE_CURRENT_BINARY_DIR}/${SRC_H} ${CMAKE_CURRENT_BINARY_DIR}/${SRC_C})
	SET(${XSD}_HEADER ${CMAKE_CURRENT_BINARY_DIR}/${SRC_H})
	ADD_CUSTOM_COMMAND(OUTPUT ${${XSD}_SRC}
		COMMAND ${XMLBEANSXX_GEN_PROG} ${CMAKE_CURRENT_SOURCE_DIR}/${XSD}
		DEPENDS generator ${XSD}
			
	)	
ENDMACRO(XMLBEANSXX_GEN)

MACRO(XMLBEANSXX_COPY SRC DEST)
	SET(${DEST}_FILE ${CMAKE_CURRENT_BINARY_DIR}/${DEST})
	ADD_CUSTOM_COMMAND(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${DEST}
		COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/${SRC} ${CMAKE_CURRENT_BINARY_DIR}/${DEST}
	)
ENDMACRO(XMLBEANSXX_COPY)
